//package ???;

import java.awt.Toolkit;

import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.Document;
import javax.swing.text.PlainDocument;

/**
 * JTextField so erweitert, dass nur eine Eingabe von Zahlen mglich ist.
 * 
 * @author Heiner K&uuml;cker
 */
public class JOnlyDigitsTextField extends JPopupMenuTextfield // JTextField
{

    /** create a JnnIntTextField with specified number of columns 
     * @param columns number of columns 
      */
    public JOnlyDigitsTextField(int columns)
    {
        super(columns);
    }

    protected Document createDefaultModel()
    {
        return new NnInt(getColumns());
    }

    static class NnInt extends PlainDocument
    {
        int columns;

        public NnInt(int pColumns)
        {
            this.columns = pColumns;
        }

        public void insertString(int offs, String str, AttributeSet a) throws BadLocationException
        {
            if (str == null)
                return;

            if (getLength() + str.length() > columns)
            {
                Toolkit.getDefaultToolkit().beep();
                return;
            }

            char[] chars = str.toCharArray();
            for (int i = 0; i < chars.length; ++i)
            {
                if (!Character.isDigit(chars[i]))
                {
                    Toolkit.getDefaultToolkit().beep();
                    return;
                }
            }

            super.insertString(offs, new String(chars), a);
        }
    }
}
