//package ???;

import java.awt.event.ActionEvent;
import java.awt.event.MouseEvent;

import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.JTextField;
import javax.swing.text.Document;

/**
 * {@link javax.swing.JTextField}mit Popup-Men fr Clipboard.
 * 
 * @author Heiner K&uuml;cker
 */
public class JPopupMenuTextfield extends JTextField
{

    /**
     * Konstruktor.
     */
    public JPopupMenuTextfield()
    {
        super();
    }

    /**
     * Konstruktor.
     * @param pText
     */
    public JPopupMenuTextfield(String pText)
    {
        super(pText);
    }

    /**
     * Konstruktor.
     * @param pColumns
     */
    public JPopupMenuTextfield(int pColumns)
    {
        super(pColumns);
    }

    /**
     * Konstruktor.
     * @param pText
     * @param pColumns
     */
    public JPopupMenuTextfield(String pText, int pColumns)
    {
        super(pText, pColumns);
    }

    /**
     * Konstruktor.
     * 
     * @param pDoc
     * @param pText
     * @param pColumns
     */
    public JPopupMenuTextfield(Document pDoc, String pText, int pColumns)
    {
        super(pDoc, pText, pColumns);
    }

    /**
     * Aufruf PopUp-Men
     */
    public void processMouseEvent(MouseEvent me)
    {
        if (me.isPopupTrigger())
        { // Popup-Men
            this.popupMenu(me);
            return;
        }
        super.processMouseEvent(me);
    }

    /**
     * Popup-Menue
     */
    public void popupMenu(final MouseEvent me)
    {
        JPopupMenu popup = new JPopupMenu();

        JMenuItem cutMenuItem = new JMenuItem("Cut");
        cutMenuItem.addActionListener(new ActionAdapter()
        {
            public void actionPerformed(ActionEvent ae)
            {
                cut();
            }
        });
        popup.add(cutMenuItem);

        JMenuItem copyMenuItem = new JMenuItem("Copy");
        copyMenuItem.addActionListener(new ActionAdapter()
        {
            public void actionPerformed(ActionEvent ae)
            {
                copy();
            }
        });
        popup.add(copyMenuItem);

        JMenuItem pasteMenuItem = new JMenuItem("Paste");
        pasteMenuItem.addActionListener(new ActionAdapter()
        {
            public void actionPerformed(ActionEvent ae)
            {
                paste();
            }
        });
        popup.add(pasteMenuItem);

        popup.show(me.getComponent(), me.getX(), me.getY());

    }
}